<?php

namespace AppBundle\Repository;

use AppBundle\Entity\Rate;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * RateRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class RateRepository extends \Doctrine\ORM\EntityRepository
{
    public function getLastRate(): ?Rate
    {
        $query = $this->createQueryBuilder('rate')
            ->select('rate')
            ->orderBy('rate.moment', 'DESC')
            ->setMaxResults(1)
            ->getQuery();

        $rate = $query->getOneOrNullResult();

        return $rate;
    }

    public function getListOfRatesDescendingByMoment(\DateTime $startTime, \DateTime $endTime): ?array
    {
        $query = $this->createQueryBuilder('rate')
            ->select('rate')
            ->andWhere('rate.moment >= :startTime')
            ->andWhere('rate.moment <= :endTime')
            ->setParameter('startTime', $startTime)
            ->setParameter('endTime', $endTime)
            ->orderBy('rate.moment', 'ASC')
            ->getQuery();

        $rates = $query->getResult();

        return $rates;
    }

    public function getListOfLastThreeRatesDescendingByMoment(): ?array
    {
        $query = $this->createQueryBuilder('rate')
            ->select('rate')
            ->orderBy('rate.moment', 'DESC')
            ->setMaxResults(5)
            ->getQuery();

        $rates = $query->getResult();
        $rates = array_reverse($rates);

        return $rates;
    }

    public function getAllRateObjectsWithoutDirectionWma($instrument, $maCount, $startDate = null, $trend = false){

        $startId = 1000;

        if($trend) {
            $rateString = sprintf('rate.trendM%s IS Null', (string) $maCount);
        } else {
            $rateString = sprintf('rate.wma%s IS Null', (string) $maCount);
        }

        $query = $this->createQueryBuilder('rate')
            ->select('rate')
            ->orderBy('rate.moment', 'ASC')
            ->andWhere('rate.mid IS NOT Null')
            ->andWhere('rate.instrument = :instrument')
            ->andWhere($rateString)
            ->andWhere('rate.id > :startId')
            ->setParameter('instrument', $instrument)
            ->setParameter('startId', $startId);

        if(!is_null($startDate)) {
            $query
                ->andWhere('rate.moment > :startDate')
                ->setParameter('startDate', $startDate);
        }

        $query->setMaxResults(200000);

        return $query->getQuery()->getResult();
    }

    public function getLastXmidsBelowDate($midCount, $instrument, $dateTime){

        $query = $this->createQueryBuilder('rate')
            ->select('rate.mid')
            ->orderBy('rate.moment', 'DESC')
            ->andWhere('rate.mid IS NOT Null')
//            ->andWhere('rate.connStatus = :connSuccess')
            ->andWhere('rate.instrument = :instrument')
            ->andWhere('rate.moment < :dateTime')
//            ->setParameter('connSuccess', 200)
            ->setParameter('instrument', $instrument)
            ->setParameter('dateTime', $dateTime)
            ->setMaxResults($midCount)
            ->getQuery();

        $result = $query->getScalarResult();

        return array_column($result,'mid');
    }

    public function getLastXMAsBelowDate($maCount, $instrument, $dateTime){

        $selectRate = sprintf('rate.ma%s', (string) $maCount);
        $where = sprintf('rate.ma%s IS NOT Null', (string) $maCount);

        $query = $this->createQueryBuilder('rate')
            ->select($selectRate)
            ->orderBy('rate.moment', 'DESC')
            ->andWhere('rate.mid IS NOT Null')
            ->andWhere($where)
//            ->andWhere('rate.connStatus = :connSuccess')
            ->andWhere('rate.instrument = :instrument')
            ->andWhere('rate.moment < :dateTime')
//            ->setParameter('connSuccess', 200)
            ->setParameter('instrument', $instrument)
            ->setParameter('dateTime', $dateTime)
            ->setMaxResults($maCount)
            ->getQuery();

        $result = $query->getScalarResult();

        $columnName = "ma{$maCount}";
        $descArray = array_column($result,$columnName);

        return array_reverse($descArray);
    }

    public function getLastXWMAsBelowDate($maCount, $instrument, $dateTime){

        $selectRate = sprintf('rate.wma%s', (string) $maCount);
        $where = sprintf('rate.wma%s IS NOT Null', (string) $maCount);

        $query = $this->createQueryBuilder('rate')
            ->select($selectRate)
            ->orderBy('rate.moment', 'DESC')
            ->andWhere('rate.mid IS NOT Null')
            ->andWhere($where)
//            ->andWhere('rate.connStatus = :connSuccess')
            ->andWhere('rate.instrument = :instrument')
            ->andWhere('rate.moment < :dateTime')
//            ->setParameter('connSuccess', 200)
            ->setParameter('instrument', $instrument)
            ->setParameter('dateTime', $dateTime)
            ->setMaxResults($maCount)
            ->getQuery();

        $result = $query->getScalarResult();

        $columnName = "wma{$maCount}";
        $descArray = array_column($result,$columnName);

        return array_reverse($descArray);
    }
}
